Matrices in floating point

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Data Structures | Typedefs | Functions
Matrices in floating point

Matrix definition and operations. More...

## Data Structures
struct | _Eina_Matrix4

## Typedefs
typedef struct _Eina_Matrix4 | Eina_Matrix4

## Functions
EAPI Eina_Matrix_Type | eina_matrix4_type_get (const Eina_Matrix4 *m)
| Return the type of the given floating point matrix. More...
EAPI void | eina_matrix4_values_set (Eina_Matrix4 *m, double xx, double xy, double xz, double xw, double yx, double yy, double yz, double yw, double zx, double zy, double zz, double zw, double wx, double wy, double wz, double ww)
| Set the values of the coefficients of the given floating point matrix. More...
EAPI void | eina_matrix4_values_get (const Eina_Matrix4 *m, double *xx, double *xy, double *xz, double *xw, double *yx, double *yy, double *yz, double *yw, double *zx, double *zy, double *zz, double *zw, double *wx, double *wy, double *wz, double *ww)
| Get the values of the coefficients of the given floating point matrix. More...
EAPI double | eina_matrix4_determinant (const Eina_Matrix4 *m)
| Return the determinant of the given matrix. More...
EAPI Eina_Bool | eina_matrix4_normalized (Eina_Matrix4 *out, const Eina_Matrix4 *in)
| Return the determinant of the given matrix. More...
EAPI Eina_Bool | eina_matrix4_inverse (Eina_Matrix4 *out, const Eina_Matrix4 *in)
| Return the inverse of the given matrix. More...
EAPI void | eina_matrix4_transpose (Eina_Matrix4 *out, const Eina_Matrix4 *in)
| Return the transpose of the given matrix. More...
EAPI void | eina_matrix4_matrix3_to (Eina_Matrix3 *m3, const Eina_Matrix4 *m4)
| Convert an Eina_Matrix4 into an Eina_Matrix3. More...
EAPI void | eina_matrix3_matrix4_to (Eina_Matrix4 *m4, const Eina_Matrix3 *m3)
| Convert an Eina_Matrix3 into an Eina_Matrix4. More...
EAPI void | eina_matrix4_identity (Eina_Matrix4 *out)
| Set an identity matrix. More...
EAPI void | eina_matrix4_multiply (Eina_Matrix4 *out, const Eina_Matrix4 *a, const Eina_Matrix4 *b)
| Multiply two matrix. More...

## Detailed Description

Matrix definition and operations.

## Function Documentation

EAPI Eina_Matrix_Type eina_matrix4_type_get | ( | const Eina_Matrix4 * | m | ) |

Return the type of the given floating point matrix.

Parameters

  m | The floating point matrix.

Returns
  The type of the matrix.

This function returns the type of the matrix `m`. No check is done on `m`.

Since
  1.15

References EINA_MATRIX_TYPE_AFFINE, and EINA_MATRIX_TYPE_IDENTITY.

EAPI void eina_matrix4_values_set | ( | Eina_Matrix4 * | m,
|  | double | xx,
|  | double | xy,
|  | double | xz,
|  | double | xw,
|  | double | yx,
|  | double | yy,
|  | double | yz,
|  | double | yw,
|  | double | zx,
|  | double | zy,
|  | double | zz,
|  | double | zw,
|  | double | wx,
|  | double | wy,
|  | double | wz,
|  | double | ww
| ) |  |

Set the values of the coefficients of the given floating point matrix.

Parameters

  m | The floating point matrix.
  xx | The first coefficient value.
  xy | The second coefficient value.
  xz | The third coefficient value.
  xw | The fourth coefficient value.
  yx | The fifth coefficient value.
  yy | The sixth coefficient value.
  yz | The seventh coefficient value.
  yw | The heighth coefficient value.
  zx | The nineth coefficient value.
  zy | The tenth coefficient value.
  zz | The eleventh coefficient value.
  zw | The twelfth coefficient value.
  wx | The thirteenth coefficient value.
  wy | The fourteenth coefficient value.
  wz | The fifteenth coefficient value.
  ww | The sizteenth coefficient value.

This function sets the values of the coefficients of the matrix `m`. No check is done on `m`.

See also
  eina_matrix4_values_get()

Since
  1.15

EAPI void eina_matrix4_values_get | ( | const Eina_Matrix4 * | m,
|  | double * | xx,
|  | double * | xy,
|  | double * | xz,
|  | double * | xw,
|  | double * | yx,
|  | double * | yy,
|  | double * | yz,
|  | double * | yw,
|  | double * | zx,
|  | double * | zy,
|  | double * | zz,
|  | double * | zw,
|  | double * | wx,
|  | double * | wy,
|  | double * | wz,
|  | double * | ww
| ) |  |

Get the values of the coefficients of the given floating point matrix.

Parameters

  m | The floating point matrix.
  xx | The first coefficient value.
  xy | The second coefficient value.
  xz | The third coefficient value.
  xw | The fourth coefficient value.
  yx | The fifth coefficient value.
  yy | The sixth coefficient value.
  yz | The seventh coefficient value.
  yw | The heighth coefficient value.
  zx | The nineth coefficient value.
  zy | The tenth coefficient value.
  zz | The eleventh coefficient value.
  zw | The twelfth coefficient value.
  wx | The thirteenth coefficient value.
  wy | The fourteenth coefficient value.
  wz | The fifteenth coefficient value.
  ww | The sizteenth coefficient value.

This function gets the values of the coefficients of the matrix `m`. No check is done on `m`.

See also
  eina_matrix4_values_set()

Since
  1.15

EAPI double eina_matrix4_determinant | ( | const Eina_Matrix4 * | m | ) |

Return the determinant of the given matrix.

Parameters

  m | The matrix.

Returns
  The determinant.

This function returns the determinant of the matrix `m`. No check is done on `m`.

Since
  1.16

Referenced by eina_matrix4_normalized().

EAPI Eina_Bool eina_matrix4_normalized | ( | Eina_Matrix4 * | out,
|  | const Eina_Matrix4 * | in
| ) |  |

Return the determinant of the given matrix.

Parameters

  m | The matrix.

Returns
  The determinant.

This function returns the determinant of the matrix `m`. No check is done on `m`.

Since
  1.16

References EINA_FALSE, eina_matrix4_determinant(), and EINA_TRUE.

EAPI Eina_Bool eina_matrix4_inverse | ( | Eina_Matrix4 * | out,
|  | const Eina_Matrix4 * | in
| ) |  |

Return the inverse of the given matrix.

Parameters

  out | The inverse matrix
  in | The matrix.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise.

Since
  1.16

References EINA_FALSE, and EINA_TRUE.

EAPI void eina_matrix4_transpose | ( | Eina_Matrix4 * | out,
|  | const Eina_Matrix4 * | in
| ) |  |

Return the transpose of the given matrix.

Parameters

  out | The transpose matrix
  in | The matrix.

Just going to swap row and column.

Since
  1.16

EAPI void eina_matrix4_matrix3_to | ( | Eina_Matrix3 * | m3,
|  | const Eina_Matrix4 * | m4
| ) |  |

Convert an Eina_Matrix4 into an Eina_Matrix3.

Parameters

  m3 | The destination Eina_Matrix3.
  m4 | The source Eina_Matrix4.

Since
  1.15

EAPI void eina_matrix3_matrix4_to | ( | Eina_Matrix4 * | m4,
|  | const Eina_Matrix3 * | m3
| ) |  |

Convert an Eina_Matrix3 into an Eina_Matrix4.

Parameters

  m3 | The destination Eina_Matrix3.
  m4 | The source Eina_Matrix4.

Since
  1.15

EAPI void eina_matrix4_identity | ( | Eina_Matrix4 * | out | ) |

Set an identity matrix.

Parameters

  out | The matrix to set

Since
  1.16

EAPI void eina_matrix4_multiply | ( | Eina_Matrix4 * | out,
|  | const Eina_Matrix4 * | a,
|  | const Eina_Matrix4 * | b
| ) |  |

Multiply two matrix.

Parameters

  out | The resulting matrix
  a | The first member of the multiplication
  b | The second member of the multiplication

Since
  1.16